#include "../inc/springprox.h"
#include <stdio.h>
#include <stdlib.h>

int main(int argc, char **argv)
{
  char buffer[64];
  char *device;
  SWORD rc;
  
  SPROX_GetLibrary(buffer, sizeof(buffer));  
  printf("Testing library       %s\n", buffer);
  
  if (argc > 1)
  {
    device = argv[1];
    printf("Looking for reader on %s\n", device);
  } else
  {
    device = NULL;
    printf("Trying to find the reader automatically...\n");
  }
  
  rc = SPROX_ReaderOpen(device);
  if (rc != MI_OK)
  {
    printf("Reader not found\n");
    return EXIT_FAILURE;
  }
  
  rc = SPROX_ReaderGetDevice(buffer, sizeof(buffer));
  if (rc == MI_OK)
  {
    printf("Reader found on       %s\n", buffer);
  } else
  {
    printf("Failed to retrieve reader's device name\n");
  }

  rc = SPROX_ReaderGetFirmware(buffer, sizeof(buffer));
  if (rc == MI_OK)
  {
    printf("Reader firmware is    %s\n", buffer);
  } else
  {
    printf("Failed to retrieve reader's firmware\n");
  }

  SPROX_ReaderClose();
  return EXIT_SUCCESS;
}

